from tkinter import *
from tkinter.ttk import *
import math

def makecanvas(txt, bgclr):
    # добавление панелиNotebook с холстом
    cnvs=Canvas(nb, background=bgclr)
    nb.add(cnvs, text=txt, padding=3)
    return cnvs

# =====================================================
# функция построения на объекте холста canvas графика непрерывной
# функции fun. График строится на отрезке [a, b],
# kx,ky - масштабные множители по осям
# положение начала координат (0, 0) в точке холста (xo, yo)
# аргумент exclude - список X координат исключаемых точек
def drawFunc(canvas, fun, a, b, kx, ky, exclude=None):
    points = []
    num = 500    # количество точек
    for n in range(num):
        x = a + (b - a) / num * n
        if exclude != None:
            if x in exclude: continue
        y = fun(x)
        # положительное направление оси Y вверх
        pp = (xo + kx * x, yo - ky * y)
        points.append(pp) # список пар (xi,yi) точек кривой
    canvas.create_line(points, fill="blue", smooth=0, width=3)  # график
    xAxe = [(xo + a * kx, yo), (xo + b * kx, yo)]
    canvas.create_line(xAxe, fill="black", width=2) # ось X
    my = max([abs(e[1] - yo) for e in points])# максимальная амплитуда
    yAxe = [(xo, yo - my * 1.05), (xo, yo + my * 1.05)]
    canvas.create_line(yAxe, fill="black", width=2)# ось Y
    maxy = min([e[1] - yo for e in points])
    gorMark = [(xo - 5, yo + maxy), (xo + 5, yo + maxy)]
    canvas.create_line(gorMark, fill="black", width=1)# засечка на оси Y
    # текстовая отметка на оси Y
    canvas.create_text(xo + 28, yo + maxy, text="{0:.3f}".format(-maxy / ky))

def g(x):
    return math.sin(x) / x
def f(x):
    return x * math.exp(-x ** 2)

root = Tk()
root.title('Графики функций')
nb = Notebook(width=480, height=360)
nb.pack(expand=1, fill='both')
# создание трех холстов на закладках виджета Notebook
cnvs1 = makecanvas('  sin(x) ', '#f7ffff')
cnvs2 = makecanvas(' sin(x)/x ' , '#fff7ff' )
cnvs3 = makecanvas(' x*exp(-x**2)', '#fffff7')
# ==============================================
# график функции sin(x)
xo, yo = 20, 180 # экранное положение начала координат
drawFunc(cnvs1, math.sin, 0, 12, 35, 150)
# график функции sin(x)/x
# исключить из рассмотрения точку x=0
xo, yo = 240, 180 # экранное положение начала координат
drawFunc(cnvs2, g, -20, 20, 11, 150, [0])
# график функции x*exp(-x**2)
xo, yo = 240, 180 # экранное положение начала координат
drawFunc(cnvs3, f, -3, 3, 80, 350)
root.mainloop()
